## org.apache.batik.bridge
Interface UserAgent

All Known Implementing Classes:
  AbstractJSVGComponent.BridgeUserAgent, AbstractJSVGComponent.BridgeUserAgentWrapper, JSVGCanvas.CanvasUserAgent, SVGAbstractTranscoder.SVGAbstractTranscoderUserAgent, UserAgentAdapter

    public interface UserAgent

An interface that provides access to the User Agent informations needed by the bridge.

Method Summary
`void` `checkLoadExternalResource(ParsedURL resourceURL, ParsedURL docURL)` This method throws a SecurityException if the resource found at url and referenced from docURL should not be loaded.
`void` `checkLoadScript(java.lang.String scriptType, ParsedURL scriptURL, ParsedURL docURL)` This method throws a SecurityException if the script of given type, found at url and referenced from docURL should not be loaded.
`void` `deselectAll()` Informs the user agent that the text selection should be cleared.
`void` `displayError(java.lang.Exception ex)` Displays an error resulting from the specified Exception.
`void` `displayMessage(java.lang.String message)` Displays a message in the User Agent interface.
`java.lang.String` `getAlternateStyleSheet()` Returns this user agent's alternate style-sheet title.
`float` `getBolderFontWeight(float f)` Returns a bolder font-weight.
`org.w3c.dom.svg.SVGDocument` `getBrokenLinkDocument(org.w3c.dom.Element e, java.lang.String url, java.lang.String message)` This method should return an image to be displayed when an image can't be loaded.
`java.awt.Point` `getClientAreaLocationOnScreen()` Returns the location on the screen of the client area in the UserAgent.
`java.lang.String` `getDefaultFontFamily()` Returns the default font family.
`EventDispatcher` `getEventDispatcher()` Returns the event dispatcher to use.
`ExternalResourceSecurity` `getExternalResourceSecurity(ParsedURL resourceURL, ParsedURL docURL)` Returns the security settings for the given resource url and document url
`java.lang.String` `getLanguages()` Returns the language settings.
`float` `getLighterFontWeight(float f)` Returns a lighter font-weight.
`java.lang.String` `getMedia()` Returns this user agent's CSS media.
`float` `getMediumFontSize()` Returns the medium font size.
`float` `getPixelToMM()` Returns the size of a px CSS unit in millimeters.
`float` `getPixelUnitToMillimeter()` Returns the size of a px CSS unit in millimeters.
`ScriptSecurity` `getScriptSecurity(java.lang.String scriptType, ParsedURL scriptURL, ParsedURL docURL)` Returns the security settings for the given script type, script url and document url
`java.awt.geom.AffineTransform` `getTransform()` Returns the `AffineTransform` currently applied to the drawing by the UserAgent.
`java.lang.String` `getUserStyleSheetURI()` Returns the user stylesheet uri.
`java.awt.geom.Dimension2D` `getViewportSize()` Returns the default size of the viewport.
`java.lang.String` `getXMLParserClassName()` Returns the class name of the XML parser.
`void` `handleElement(org.w3c.dom.Element elt, java.lang.Object data)` Notifies the UserAgent that the input element has been found in the document.
`boolean` `hasFeature(java.lang.String s)` Tells whether the given feature is supported by this user agent.
`boolean` `isXMLParserValidating()` Returns true if the XML parser must be in validation mode, false otherwise.
`void` `openLink(org.w3c.dom.svg.SVGAElement elt)` Opens a link.
`void` `registerExtension(BridgeExtension ext)` Lets the bridge tell the user agent that the following extension is supported by the bridge.
`void` `setSVGCursor(java.awt.Cursor cursor)` Informs the user agent to change the cursor.
`void` `setTextSelection(Mark start, Mark end)` Informs the user agent that the text selection has changed.
`void` `setTransform(java.awt.geom.AffineTransform at)` Sets the `AffineTransform` currently applied to the drawing by the UserAgent.
`void` `showAlert(java.lang.String message)` Shows an alert dialog box.
`boolean` `showConfirm(java.lang.String message)` Shows a confirm dialog box.
`java.lang.String` `showPrompt(java.lang.String message)` Shows a prompt dialog box.
`java.lang.String` `showPrompt(java.lang.String message, java.lang.String defaultValue)` Shows a prompt dialog box.
`boolean` `supportExtension(java.lang.String s)` Tells whether the given extension is supported by this user agent.

Method Detail

### getEventDispatcher

    EventDispatcher getEventDispatcher()

  Returns the event dispatcher to use.

### getViewportSize

    java.awt.geom.Dimension2D getViewportSize()

  Returns the default size of the viewport.

### displayError

    void displayError(java.lang.Exception ex)

  Displays an error resulting from the specified Exception.

### displayMessage

    void displayMessage(java.lang.String message)

  Displays a message in the User Agent interface.

### showAlert

    void showAlert(java.lang.String message)

  Shows an alert dialog box.

### showPrompt

    java.lang.String showPrompt(java.lang.String message)

  Shows a prompt dialog box.

### showPrompt

    java.lang.String showPrompt(java.lang.String message,
                                java.lang.String defaultValue)

  Shows a prompt dialog box.

### showConfirm

    boolean showConfirm(java.lang.String message)

  Shows a confirm dialog box.

### getPixelUnitToMillimeter

    float getPixelUnitToMillimeter()

  Returns the size of a px CSS unit in millimeters.

### getPixelToMM

    float getPixelToMM()

  Returns the size of a px CSS unit in millimeters. This will be removed after next release.

  See Also:
    `getPixelUnitToMillimeter()`

### getMediumFontSize

    float getMediumFontSize()

  Returns the medium font size.

### getLighterFontWeight

    float getLighterFontWeight(float f)

  Returns a lighter font-weight.

### getBolderFontWeight

    float getBolderFontWeight(float f)

  Returns a bolder font-weight.

### getDefaultFontFamily

    java.lang.String getDefaultFontFamily()

  Returns the default font family.

### getLanguages

    java.lang.String getLanguages()

  Returns the language settings.

### getUserStyleSheetURI

    java.lang.String getUserStyleSheetURI()

  Returns the user stylesheet uri.

  Returns:
    null if no user style sheet was specified.

### openLink

    void openLink(org.w3c.dom.svg.SVGAElement elt)

  Opens a link.

  Parameters:
    `elt` - The activated link element.

### setSVGCursor

    void setSVGCursor(java.awt.Cursor cursor)

  Informs the user agent to change the cursor.

  Parameters:
    `cursor` - the new cursor

### setTextSelection

    void setTextSelection(Mark start,
                          Mark end)

  Informs the user agent that the text selection has changed.

  Parameters:
    `start` - The Mark for the start of the selection.
    `end` - The Mark for the end of the selection.

### deselectAll

    void deselectAll()

  Informs the user agent that the text selection should be cleared.

### getXMLParserClassName

    java.lang.String getXMLParserClassName()

  Returns the class name of the XML parser.

### isXMLParserValidating

    boolean isXMLParserValidating()

  Returns true if the XML parser must be in validation mode, false otherwise.

### getTransform

    java.awt.geom.AffineTransform getTransform()

  Returns the `AffineTransform` currently applied to the drawing by the UserAgent.

### setTransform

    void setTransform(java.awt.geom.AffineTransform at)

  Sets the `AffineTransform` currently applied to the drawing by the UserAgent.

### getMedia

    java.lang.String getMedia()

  Returns this user agent's CSS media.

### getAlternateStyleSheet

    java.lang.String getAlternateStyleSheet()

  Returns this user agent's alternate style-sheet title.

### getClientAreaLocationOnScreen

    java.awt.Point getClientAreaLocationOnScreen()

  Returns the location on the screen of the client area in the UserAgent.

### hasFeature

    boolean hasFeature(java.lang.String s)

  Tells whether the given feature is supported by this user agent.

### supportExtension

    boolean supportExtension(java.lang.String s)

  Tells whether the given extension is supported by this user agent.

### registerExtension

    void registerExtension(BridgeExtension ext)

  Lets the bridge tell the user agent that the following extension is supported by the bridge.

### handleElement

    void handleElement(org.w3c.dom.Element elt,
                       java.lang.Object data)

  Notifies the UserAgent that the input element has been found in the document. This is sometimes called, for example, to handle <a> or <title> elements in a UserAgent-dependant way.

### getScriptSecurity

    ScriptSecurity getScriptSecurity(java.lang.String scriptType,
                                     ParsedURL scriptURL,
                                     ParsedURL docURL)

  Returns the security settings for the given script type, script url and document url

  Parameters:
    `scriptType` - type of script, as found in the type attribute of the <script> element.
    `scriptURL` - url for the script, as defined in the script's xlink:href attribute. If that attribute was empty, then this parameter should be null
    `docURL` - url for the document into which the script was found.

### checkLoadScript

    void checkLoadScript(java.lang.String scriptType,
                         ParsedURL scriptURL,
                         ParsedURL docURL)
                         throws java.lang.SecurityException

  This method throws a SecurityException if the script of given type, found at url and referenced from docURL should not be loaded. This is a convenience method to call checkLoadScript on the ScriptSecurity strategy returned by getScriptSecurity.

  Parameters:
    `scriptType` - type of script, as found in the type attribute of the <script> element.
    `scriptURL` - url for the script, as defined in the script's xlink:href attribute. If that attribute was empty, then this parameter should be null
    `docURL` - url for the document into which the script was found.
  Throws:
    `java.lang.SecurityException`

### getExternalResourceSecurity

    ExternalResourceSecurity getExternalResourceSecurity(ParsedURL resourceURL,
                                                         ParsedURL docURL)

  Returns the security settings for the given resource url and document url

  Parameters:
    `resourceURL` - url for the resource, as defined in the resource's xlink:href attribute. If that attribute was empty, then this parameter should be null
    `docURL` - url for the document into which the resource was found.

### checkLoadExternalResource

    void checkLoadExternalResource(ParsedURL resourceURL,
                                   ParsedURL docURL)
                                   throws java.lang.SecurityException

  This method throws a SecurityException if the resource found at url and referenced from docURL should not be loaded. This is a convenience method to call checkLoadExternalResource on the ExternalResourceSecurity strategy returned by getExternalResourceSecurity.

  Parameters:
    `resourceURL` - url for the resource, as defined in the resource's xlink:href attribute. If that attribute was empty, then this parameter should be null
    `docURL` - url for the document into which the resource was found.
  Throws:
    `java.lang.SecurityException`

### getBrokenLinkDocument

    org.w3c.dom.svg.SVGDocument getBrokenLinkDocument(org.w3c.dom.Element e,
                                                      java.lang.String url,
                                                      java.lang.String message)

  This method should return an image to be displayed when an image can't be loaded. If it returns 'null' then a BridgeException will be thrown.

  Parameters:
    `e` - The <image> element that can't be loaded.
    `url` - The resolved url that can't be loaded.
    `message` - As best as can be determined the reason it can't be loaded (not available, corrupt, unknown format, ...).

Copyright © 2008 Apache Software Foundation. All Rights Reserved.